﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IndustryConnect.Bootcamp.Two
{
    class Program
    {
        static void Main(string[] args)
        {

            var array = new[] { 6, 1, 2, 9, 10, 2 };

            Print(array.Min()); // 1

            Print(array.Max()); // 10

            Print(array.Average()); // 5

            Print(array.Sum()); // 30

            Print(array.First()); // 6, Also Check out FirstOrDefault

            Print(array.Last()); // 2, Also Check out LastOrDefault

            PrintList(array.Select(n => n + 1)); // 7, 2, 3, 10, 11, 3 Produced new list

            PrintList(array.Reverse()); // 2,10,9,2,1,6  Reversed the list

            PrintList(array.OrderBy(n => n)); // 1,2,2,6,9,10

            PrintList(array.OrderByDescending(n => n)); // 10,9,6,2,2,1

            PrintList(array.Take(3)); // 6,1,2

            PrintList(array.TakeWhile(n => n < 9)); //6,1,2  TakeWhile stops when the condition is false

            PrintList(array.Skip(3)); // 9,10,2

            PrintList(array.SkipWhile(n => n < 9)); // 6,1,2,9,10,2

            PrintList(array.Where(n => n == 2)); // 2,2   Where continues and find all elements matching the condition

            PrintList(array.Distinct()); // 6,1,2,9,10

            PrintList(array.Except(new[] { 6, 1 })); //2,9,10   Remove the numbers from given list

            Console.ReadKey();
        }

        static void Print(object obj)
        {
            Console.WriteLine(obj);
            Debug.WriteLine(obj);
        }

        static void PrintList<T>(IEnumerable<T> obj)
        {
            Print(string.Join<T>(",", obj));
        }
    }
}
